package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.CouponService;
import com.gxwebsoft.shop.entity.Coupon;
import com.gxwebsoft.shop.param.CouponParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 控制器
 *
 * @author 科技小王子
 * @since 2025-12-03 13:47:42
 */
@Api(tags = "管理")
@RestController
@RequestMapping("/api/shop/coupon")
public class CouponController extends BaseController {
    @Resource
    private CouponService couponService;

    @ApiOperation("分页查询")
    @GetMapping("/page")
    public ApiResult<PageResult<Coupon>> page(CouponParam param) {
        // 使用关联查询
        return success(couponService.pageRel(param));
    }

    @ApiOperation("查询全部")
    @GetMapping()
    public ApiResult<List<Coupon>> list(CouponParam param) {
        // 使用关联查询
        return success(couponService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:coupon:list')")
    @ApiOperation("根据id查询")
    @GetMapping("/{id}")
    public ApiResult<Coupon> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(couponService.getByIdRel(id));
    }

    @ApiOperation("添加")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Coupon coupon) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         coupon.setUserId(loginUser.getUserId());
        }
        if (couponService.save(coupon)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Coupon coupon) {
        if (couponService.updateById(coupon)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (couponService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Coupon> list) {
        if (couponService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Coupon> batchParam) {
        if (batchParam.update(couponService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (couponService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
